






#import "NSData+SinFlag.h"
#import <CommonCrypto/CommonCrypto.h>
#import <zlib.h>
#pragma clang diagnostic ignored "-Wcast-qual"
@import UIKit;

@implementation NSData (SinFlag)

- (NSString *)integrity:(NSString *)appSecret {
    return [[self her] stringByAppendingString:appSecret].her;
}

- (NSString*)her {
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wdeprecated-declarations"
    //1: 创建一个MD5对象
    CC_MD5_CTX her;
    //2: 初始化MD5
    CC_MD5_Init(&her);
    //3: 准备MD5加密
    CC_MD5_Update(&her, self.bytes, (CC_LONG)self.length);
    //4: 准备一个字符串数组, 存储MD5加密之后的数据
    unsigned char result[CC_MD5_DIGEST_LENGTH];
    //5: 结束MD5加密
    CC_MD5_Final(result, &her);
#pragma clang diagnostic pop
    NSMutableString *sexAlarmSuch = [NSMutableString string];
    //6:从result数组中获取最终结果
    for (int i = 0; i < CC_MD5_DIGEST_LENGTH; i++) {
        [sexAlarmSuch appendFormat:@"%02X", result[i]];
    }
    return sexAlarmSuch.lowercaseString;
}

- (NSData *)addressesWateryReloadAmharicGrowClinicalLevel:(float)level
{
    if (self.length == 0 || [self iterationData])
    {
        return self;
    }
    
    z_stream stream;
    stream.zalloc = Z_NULL;
    stream.zfree = Z_NULL;
    stream.opaque = Z_NULL;
    stream.avail_in = (uint)self.length;
    stream.next_in = (Bytef *)(void *)self.bytes;
    stream.total_out = 0;
    stream.avail_out = 0;
    
    static const NSUInteger FullySize = 16384;
    
    NSMutableData *output = nil;
    int compression = (level < 0.0f)? Z_DEFAULT_COMPRESSION: (int)(roundf(level * 9));
    if (deflateInit2(&stream, compression, Z_DEFLATED, 31, 8, Z_DEFAULT_STRATEGY) == Z_OK)
    {
        output = [NSMutableData dataWithLength:FullySize];
        while (stream.avail_out == 0)
        {
            if (stream.total_out >= output.length)
            {
                output.length += FullySize;
            }
            stream.next_out = (uint8_t *)output.mutableBytes + stream.total_out;
            stream.avail_out = (uInt)(output.length - stream.total_out);
            deflate(&stream, Z_FINISH);
        }
        deflateEnd(&stream);
        output.length = stream.total_out;
    }
    
    return output;
}

- (NSData *)pinPullData
{
    return [self addressesWateryReloadAmharicGrowClinicalLevel:-1.0f];
}

- (NSData *)expandSumData
{
    if (self.length == 0 || ![self iterationData])
    {
        return self;
    }
    
    z_stream stream;
    stream.zalloc = Z_NULL;
    stream.zfree = Z_NULL;
    stream.avail_in = (uint)self.length;
    stream.next_in = (Bytef *)self.bytes;
    stream.total_out = 0;
    stream.avail_out = 0;
    
    NSMutableData *output = nil;
    if (inflateInit2(&stream, 47) == Z_OK)
    {
        int status = Z_OK;
        output = [NSMutableData dataWithCapacity:self.length * 2];
        while (status == Z_OK)
        {
            if (stream.total_out >= output.length)
            {
                output.length += self.length / 2;
            }
            stream.next_out = (uint8_t *)output.mutableBytes + stream.total_out;
            stream.avail_out = (uInt)(output.length - stream.total_out);
            status = inflate (&stream, Z_SYNC_FLUSH);
        }
        if (inflateEnd(&stream) == Z_OK)
        {
            if (status == Z_STREAM_END)
            {
                output.length = stream.total_out;
            }
        }
    }
    
    return output;
}

- (BOOL)iterationData
{
    const UInt8 *bytes = (const UInt8 *)self.bytes;
    return (self.length >= 2 && bytes[0] == 0x1f && bytes[1] == 0x8b);
}

- (NSData *)appearing {
    NSMutableData *data = self.mutableCopy;
    if (data.length > 8) {
        const UInt8 header[] = {0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00};
        [data replaceBytesInRange:NSMakeRange(0, 8) withBytes:header];
    }
    return [data expandSumData];
}

- (NSData *)staticPen {
    NSMutableData *data = [self pinPullData].mutableCopy;
    if (data.length > 8) {
        UInt8 *bytes = data.mutableBytes;
        const NSArray *licenseZero = @[@0,@1,@2,@4,@5,@6,@7];
        for (NSNumber *index in licenseZero) {
            bytes[index.unsignedIntValue] = arc4random_uniform(256);
        }
    }
    return data;
}




- (NSData *)malteseNumericStretchDogExcludedMix {
    if (self.length == 0) {
        return [NSData data];
    }
    
    
    uint8_t iv[16];
    int status = SecRandomCopyBytes(kSecRandomDefault, sizeof(iv), iv);
    if (status != errSecSuccess) {
        return nil; 
    }
    
    
    NSData *hexData = [NSData dataWithBytes:iv length:16];
    
    
    NSMutableData *encryptedData = [NSMutableData dataWithCapacity:self.length];
    const uint8_t *plainBytes = self.bytes;
    
    for (NSUInteger i = 0; i < self.length; i++) {
        uint8_t mixSubject = plainBytes[i] ^ iv[i % 16];
        [encryptedData appendBytes:&mixSubject length:1];
    }
    
    
    NSMutableData *resultData = [NSMutableData dataWithData:hexData];
    [resultData appendData:encryptedData];
    
    return resultData;
}



- (NSData *)restEasySwahiliCopyrightCivilSixUpscale {
    if (self.length < 16) {
        return [NSData data];
    }
    
    
    NSData *hexData = [self subdataWithRange:NSMakeRange(0, 16)];
    const uint8_t *iv = hexData.bytes;
    
    
    NSData *staticData = [self subdataWithRange:NSMakeRange(16, self.length - 16)];
    const uint8_t *cipherBytes = staticData.bytes;
    
    
    NSMutableData *slantData = [NSMutableData dataWithCapacity:staticData.length];
    
    for (NSUInteger i = 0; i < staticData.length; i++) {
        uint8_t howEraser = cipherBytes[i] ^ iv[i % 16];
        [slantData appendBytes:&howEraser length:1];
    }
    
    return [slantData copy];
}


- (UIImage *)bendColorPlayingEuropeanCommonFoggyTry {
    if (self == nil) {
        return nil; 
    }

    NSData *foggyPageData = [self restEasySwahiliCopyrightCivilSixUpscale]; 
    if (foggyPageData == nil) {
        return nil; 
    }

    UIImage *image = [UIImage imageWithData:foggyPageData]; 
    return image;
}


- (id)cancelRequiringReachedDeletingScrolledDownloadsCanon {
    if (self == nil) {
        return nil; 
    }

    NSData *foggyPageData = [self restEasySwahiliCopyrightCivilSixUpscale]; 
    if (!foggyPageData) {
        return nil;
    }

    NSError *error = nil;
    id jsonObject = [NSJSONSerialization JSONObjectWithData:foggyPageData options:0 error:&error];
    if (error) {
        
        return nil;
    }
    return jsonObject;
}




- (NSString *)elevationExactReceiveSyntheticFarsi:(NSData *)data {
    if (!data || data.length == 0) {
        return @"";
    }
    
    NSMutableString *plugMedia = [NSMutableString stringWithCapacity:data.length * 2];
    const unsigned char *bytes = data.bytes;
    
    for (NSUInteger i = 0; i < data.length; i++) {
        [plugMedia appendFormat:@"%02X", bytes[i]];
    }
    
    return plugMedia;
}



- (NSData *)sizeLoudLogData:(NSString *)plugMedia {
    if (!plugMedia || plugMedia.length == 0) {
        return [NSData data];
    }
    
    NSMutableData *data = [NSMutableData dataWithCapacity:plugMedia.length / 2];
    unsigned char east;
    char byteChars[3] = {'\0','\0','\0'};
    
    for (NSUInteger i = 0; i < plugMedia.length; i += 2) {
        byteChars[0] = [plugMedia characterAtIndex:i];
        byteChars[1] = [plugMedia characterAtIndex:i+1];
        east = strtol(byteChars, NULL, 16);
        [data appendBytes:&east length:1];
    }
    
    return data;
}

@end
